<?php 

/***************************************************************** 
*                     ftp-online fr proftpd                     *
*               PHP-Verbindungsviewer fr proftpd                * 
*   Download: http://www.proftpd.de/forum2/viewtopic.php?t=283   * 
*                   ftp-online@woerstenfeld.de                   * 
*                 Version 1.03n - 28.03.2006 18:07               * 
******************************************************************
* NDERUNGEN                                                     *
* 1.03n - Support fr 1.3.0 (function check_version)             *
* 1.03n - Killfunktion deaktivierbar                             *
*****************************************************************/

/**** Konfiguration ****/
$KONF["debug"]        = "0";                            // Debugmodus an = 1
$KONF["font"]         = "Verdana";                      // Schriftart auf der Website
$KONF["refresh"]      = "2";                            // Webseite alle x Sekunden neu laden 
$KONF["sprache"]      = "GE";                           // Website-Language (GE=German EN=English PL=Polish HE=Hessisch DA=Danish)
$KONF["display"]      = "1";                            // 0=nix, 1=Icon, 2=Text, 3=Icon+Text
$KONF["singleline"]   = "1";                            // Einzeilig oder mehrzeilig (ab 1.2.8)
$KONF["kill"]         = "0";                            // Killfunktion erlaubt?

/**** German ****/
include "./strings/ge.inc.php";

/**** English ****/
include "./strings/en.inc.php";

/**** Polish by sajmon@tenboard.com ****/
include "./strings/pl.inc.php";

/**** Hessisch fun tiger@4tiger.de ****/
include "./strings/he.inc.php";

/**** Danish by Svenning Krogager (svenning@krogager.dk) ****/
include "./strings/da.inc.php";

debug("Strings eingelesen"); 
debug($STR); 

$KONF["images"]       = "images/";                      // Bilderverzeichnis
$KONF["button1"]      = '<IMG alt=""                                       src="'.$KONF["images"].'start.gif"    width="64" height="25" border="0">'; // Startknopf 
$KONF["button2"]      = '<IMG alt=""                                       src="'.$KONF["images"].'stop.gif"     width="64" height="25" border="0">'; // Stoppknopf 
$KONF["img_server"]   = '<IMG alt="'.$STR[$KONF["sprache"]]["server"].'"   src="'.$KONF["images"].'server.gif"   width="16" height="16">';            // Serverbild
$KONF["img_client"]   = '<IMG alt="'.$STR[$KONF["sprache"]]["client"].'"   src="'.$KONF["images"].'client.gif"   width="16" height="16">';            // Benutzerbild
$KONF["img_location"] = '<IMG alt="'.$STR[$KONF["sprache"]]["location"].'" src="'.$KONF["images"].'location.gif" width="16" height="16">';            // Verzeichnisbild
$KONF["img_status"]   = '<IMG alt="'.$STR[$KONF["sprache"]]["status"].'"   src="'.$KONF["images"].'status.gif"   width="16" height="16">';            // Statusbild
$KONF["img_pid"]      = '<IMG alt="'.$STR[$KONF["sprache"]]["PID"].'"      src="'.$KONF["images"].'pid.gif"      width="16" height="16">';            // Prozessbild
$KONF["img_user"]     = '<IMG alt="'.$STR[$KONF["sprache"]]["login"].'"    src="'.$KONF["images"].'user.gif"     width="16" height="16">';            // Loginnamebild

debug("Konfiguration eingelesen"); 
debug($KONF); 

$PRG["befehl"]        = "/usr/bin/ftpwho -v ";           // Befehl um aktive Verbindungen auszulesen
$PRG["einezeile"]     = " -o oneline";                         // Befehl um aktive Verbindungen einzeilig anzuzeigen
$PRG["killbefehl"]    = "/bin/kill -15";                       // Auszufuehrender kill-Befehl 
$PRG["verbefehl"]     = "/usr/sbin/proftpd -v 2>&1";     // Befehl um die proftpd-Version auszulesen
$PRG["tempfile"]      = "/tmp/ftp.online";                     // Temporre Datei 

debug("Programme eingelesen"); 
debug($PRG); 

/****  Programm ****/

/**** Version auslesen ****/

debug("Rufe Funktion check_version auf um die Version zu prfen");  
$INT["version"] = check_version();  

debug("Unbekannte Version?");  
if ($INT["version"] == false)       
{
    debug("Ja. Abbrechen!");  
    
    debug("Setze Ausgabe vom Befehl in ".$PRG["verbefehl"]." als Version");
    $INT["version"] = str_replace("\n", "",shell_exec($PRG["verbefehl"]));  

    debug("Bastle Texte fr die Fehlermeldung zusammen");
    $output  = "<BR><FONT color=\"#C00000\" face=\"".$KONF["font"]."\">".$STR[$KONF["sprache"]]["nosupp"]." <b>".$INT["version"]."</b><BR>\n";
    $output .= $STR[$KONF["sprache"]]["contact"]."<a href=\"mailto:ftp-online@woerstenfeld.de?subject=ftponline_".$INT["version"]."\">ftp-online@woerstenfeld.de</a>.</FONT>";

    debug("Rufe Funktion write_body auf");  
    write_body(); 

    debug("Programm abbrechen");  
    exit;
}
else
{
    debug("Nein. Weiter geht es...");  
}

debug("Prfe, ob automatisch aktualisiert werden soll (Wenn im URL 'loop' bergeben wurde)");  
if (!isset($_GET["loop"])) 
{ 
  debug("Ja.");  
  
  debug("Aktiviere die automatische Aktualisierung");  
  $do_refresh     = true;       
  
  debug("Setzte den Link fr den StartStoppKnopf auf 'Stopp'");  
  $start_stop     = "?loop=0";      

  debug("Setzte den StartStoppKnopf auf 'Stopp'");  
  $KONF["button"] = $KONF["button2"];
} 
else 
{ 
  debug("Nein.");  
  
  debug("Lsche den Link fr den StartStoppKnopf");  
  $start_stop     = "";
  
  debug("Setzte den StartStoppKnopf auf 'Start'");  
  $KONF["button"] = $KONF["button1"];   
} 

debug("Fhre Befehl <b>".$PRG["befehl"]." &gt; ".$PRG["tempfile"]."</b> aus");  
$command = shell_exec($PRG["befehl"]." > ".$PRG["tempfile"]); 
debug("Lese Datei <b>".$PRG["tempfile"]."</b> ein");  
$handle  = fopen ($PRG["tempfile"], "r"); 
if ($handle) 
{ 
  $output = "<FONT size=\"-2\" face=\"".$KONF["font"]."\">\n"; 
  debug("Lese Datei ".$PRG["tempfile"]." ein bis sie alle ist");  
  while (!feof ($handle)) 
   { 
    debug("<b>Lese Hppchen aus ".$PRG["tempfile"]." ein...</b>");  
    $buffer = fgets($handle, 4096);                 
    debug("Wenn ein '\\n' enthalten ist setze einen Zeilenumbruch ans Ende der Zeile.");  
    if (strstr($buffer,"\n")) $output .= "<BR>";    
    debug("Wenn ein 'Service class' enthalten ist setze eine Linie ans Ende der Zeile.");  
    if (strstr($buffer,"Service class")) $output .= "<HR>";         
    debug("Wenn ein 'host' oder 'cwd' enthalten ist lsche alle Klammern in der Zeile.");  
    if (strstr($buffer,"(host") || strstr($buffer,"(cwd")) 
    {
        debug("Ersetze linke Klammern durch nichts");  
        $buffer = str_replace("(", "",$buffer); 
        debug("Ersetze rechte Klammern durch nichts");  
        $buffer = str_replace(")", "",$buffer); 
    }
    
    debug("Ist ein 'STOR' oder 'RETR' oder 'idle' oder 'IDLE' oder 'authenticating' oder 'DELE' enthalten?");  
    debug($buffer);
    if (strstr($buffer,"LIST") || strstr($buffer,"STOR") || strstr($buffer,"RETR") || strstr($buffer,"idle") || strstr($buffer,"IDLE") || strstr($buffer,"authenticating") || strstr($buffer,"DELE"))   
    {
    //Beispiele
    //1.2.5     Array ( [0] => 27650 [1] => 0m3s [2] => [3] => [4] => proftpd: [5] => tacdata [6] => - [7] => 10.138.134.159: [8] => IDLE )
    //1.2.8p    Array ( [0] => 27217 [1] => tacdata [2] => [3] => [ [4] => [5] => 2m1s] [6] => [7] => [8] => 2m1s [9] => (idle) )
    //1.2.9RC2p Array ( [0] => 27467 [1] => tacdata [2] => [3] => [ [4] => [5] => 0m2s] [6] => [7] => [8] => 0m2s [9] => idle )

    debug("Ja - zerlege die Zeile in Hppchen");  
    $pieces = explode(" ",  ltrim($buffer)); 
    debug($pieces); 
    
    debug("Setze loginnamen"); 
    if ($INT["version"] == "1.2.5") $username = $pieces[5];
    if ($INT["version"] == "1.2.6") $username = $pieces[5];
    if ($INT["version"] == "1.2.8") $username = $pieces[2];
    if ($INT["version"] == "1.2.9") $username = $pieces[1];
    if ($INT["version"] == "1.2.10") $username = $pieces[1];
    
    debug("Setze ProzessID"); 
    if ($INT["version"] == "1.2.5") $PID = $pieces[1];
    if ($INT["version"] == "1.2.6") $PID = $pieces[1];
    if ($INT["version"] == "1.2.8") $PID = $pieces[1];
    if ($INT["version"] == "1.2.9") $PID = $pieces[0];
    if ($INT["version"] == "1.2.10") $PID = $pieces[0];

    debug("Wurde dem Browser eine ProzessID (".$_GET["kill_pid"].") bergeben und ist diese die selbe PozessID ($PID)?"); 
    if (intval($_GET["kill_pid"]) == intval($PID) )
    {
     debug("Ja. Ersetze die PID durch den Text".$STR[$KONF["sprache"]]["PIDkill"]." (PID)"); 
    if ($KONF["display"] == 0) 
    {
        // Nix
        $buffer = str_replace("$PID", "<font color=red><b>&nbsp; $PID</font></b>",$buffer); 
    }
    elseif ($KONF["display"] == 1)
    {
        //Icons
        $buffer = str_replace("$PID", $KONF["img_pid"] ."<font color=red><b>&nbsp; $PID</font></b>",$buffer); 
    }
    elseif ($KONF["display"] == 2)
    {
        //Text
        $buffer = str_replace("$PID", "<font color=red><b>&nbsp;".$STR[$KONF["sprache"]]["PIDkill"]." ($PID)</font></b>",$buffer); 
    }
    else
    {
        //Text+Icons (default)
        $buffer = str_replace("$PID", $KONF["img_pid"] ."<font color=red><b>&nbsp;".$STR[$KONF["sprache"]]["PIDkill"]." ($PID)</font></b>",$buffer); 
    }
    }
    else
    {
     debug("Nein. Ersetze die PID durch einen Link der PID mit Bild davor zum Anklicken"); 
    if ($KONF["display"] == 0) 
    {
        // Nix
        $buffer = str_replace("$PID", "<font color=blue><b>&nbsp;</b></font>&nbsp;<a href=\"?kill_pid=$PID&amp;cs=".(md5($PID))."\"><font color=\"#000000\">$PID</FONT></a>",$buffer); 
    }
    elseif ($KONF["display"] == 1)
    {
        //Icons
        $buffer = str_replace("$PID", $KONF["img_pid"] ."<font color=blue><b>&nbsp;</b></font>&nbsp;<a href=\"?kill_pid=$PID&amp;cs=".(md5($PID))."\"><font color=\"#000000\">$PID</FONT></a>",$buffer); 
    }
    elseif ($KONF["display"] == 2)
    {
        //Text
        $buffer = str_replace("$PID", "<font color=blue><b>&nbsp;".$STR[$KONF["sprache"]]["PID"]."</b></font>&nbsp;<a href=\"?kill_pid=$PID&amp;cs=".(md5($PID))."\"><font color=\"#000000\">$PID</FONT></a>",$buffer); 
    }
    else
    {
        //Text+Icons (default)
        $buffer = str_replace("$PID", $KONF["img_pid"] ."<font color=blue><b>&nbsp;".$STR[$KONF["sprache"]]["PID"]."</b></font>&nbsp;<a href=\"?kill_pid=$PID&amp;cs=".(md5($PID))."\"><font color=\"#000000\">$PID</FONT></a>",$buffer); 
    }
    }   

     debug("Formatiere Loginnamen und Status und ein Bild davor"); 
     if ($KONF["display"] == 0) 
     {
        // Nix
        $buffer = str_replace("$username", "<font color=blue><b>&nbsp;</b></font>&nbsp;$username <font color=blue><b>&nbsp;</b></font>",$buffer); 
     }
     elseif ($KONF["display"] == 1)
     {
        //Icons
        $buffer = str_replace("$username", $KONF["img_user"] ."<font color=blue><b>&nbsp;</b></font>&nbsp;$username ".$KONF["img_status"] ."<font color=blue><b>&nbsp;</b></font>",$buffer);    
     }
     elseif ($KONF["display"] == 2)
     {
        //Text
        $buffer = str_replace("$username", "<font color=blue><b>&nbsp;".$STR[$KONF["sprache"]]["login"]."</b></font>&nbsp;$username <font color=blue><b>&nbsp;".$STR[$KONF["sprache"]]["status"]."</b></font>",$buffer); 
     }
     else
     {
        //Text+Icons (default)
        $buffer = str_replace("$username", $KONF["img_user"] ."<font color=blue><b>&nbsp;".$STR[$KONF["sprache"]]["login"]."</b></font>&nbsp;$username ".$KONF["img_status"] ."<font color=blue><b>&nbsp;".$STR[$KONF["sprache"]]["status"]."</b></font>",$buffer); 
     }
    }
    else
    {
        debug("Nein."); 
    }

    debug("Formatiere Benutzer,Server und Verzeichnis Text"); 
    if ($INT["version"] == "1.2.5" || $INT["version"] == "1.2.6") $buffer = str_replace("proftpd:",  "<BR>",$buffer); 
     
     if ($KONF["display"] == 0) 
     {
        // Nix
        $buffer = str_replace("host:",     "<font color=blue><b>&nbsp;</b></font>",$buffer); 
        $buffer = str_replace("cwd:",      "<font color=blue><b>&nbsp;</b></font>",$buffer); 
        $buffer = str_replace("client:",   "<font color=blue><b>&nbsp;</b></font>",$buffer); 
        $buffer = str_replace("server:",   "<font color=blue><b>&nbsp;</b></font>",$buffer); 
        $buffer = str_replace("location:", "<font color=blue><b>&nbsp;</b></font>",$buffer); 
     }
     elseif ($KONF["display"] == 1)
     {
        //Icons
        $buffer = str_replace("host:",     $KONF["img_client"]   ."<font color=blue><b>&nbsp;</b></font>",$buffer); 
        $buffer = str_replace("cwd:",      $KONF["img_location"] ."<font color=blue><b>&nbsp;</b></font>",$buffer); 
        $buffer = str_replace("client:",   $KONF["img_client"]   ."<font color=blue><b>&nbsp;</b></font>",$buffer); 
        $buffer = str_replace("server:",   $KONF["img_server"]   ."<font color=blue><b>&nbsp;</b></font>",$buffer); 
        $buffer = str_replace("location:", $KONF["img_location"] ."<font color=blue><b>&nbsp;</b></font>",$buffer); 
     }
     elseif ($KONF["display"] == 2)
     {
        //Text
        $buffer = str_replace("host:",     "<font color=blue><b>&nbsp;".$STR[$KONF["sprache"]]["client"]."</b></font>",$buffer); 
        $buffer = str_replace("cwd:",      "<font color=blue><b>&nbsp;".$STR[$KONF["sprache"]]["location"]."</b></font>",$buffer); 
        $buffer = str_replace("client:",   "<font color=blue><b>&nbsp;".$STR[$KONF["sprache"]]["client"]."</b></font>",$buffer); 
        $buffer = str_replace("server:",   "<font color=blue><b>&nbsp;".$STR[$KONF["sprache"]]["server"]."</b></font>",$buffer); 
        $buffer = str_replace("location:", "<font color=blue><b>&nbsp;".$STR[$KONF["sprache"]]["location"]."</b></font>",$buffer); 
     }
     else
     {
        //Text+Icons (default)
        $buffer = str_replace("host:",     $KONF["img_client"]   ."<font color=blue><b>&nbsp;".$STR[$KONF["sprache"]]["client"]."</b></font>",$buffer); 
        $buffer = str_replace("cwd:",      $KONF["img_location"] ."<font color=blue><b>&nbsp;".$STR[$KONF["sprache"]]["location"]."</b></font>",$buffer); 
        $buffer = str_replace("client:",   $KONF["img_client"]   ."<font color=blue><b>&nbsp;".$STR[$KONF["sprache"]]["client"]."</b></font>",$buffer); 
        $buffer = str_replace("server:",   $KONF["img_server"]   ."<font color=blue><b>&nbsp;".$STR[$KONF["sprache"]]["server"]."</b></font>",$buffer); 
        $buffer = str_replace("location:", $KONF["img_location"] ."<font color=blue><b>&nbsp;".$STR[$KONF["sprache"]]["location"]."</b></font>",$buffer); 
     }

    

    debug("Formatiere Statustexte (RETR,idle,STOR,DELE)"); 
    $buffer = str_replace("DELE", "<font color=red><b>".$STR[$KONF["sprache"]]["DELE"]."</b></font>",$buffer); 
    $buffer = str_replace("RETR", "<font color=red><b>".$STR[$KONF["sprache"]]["RETR"]."</b></font>",$buffer); 
    $buffer = str_replace("idle", "<font color=green><b>".$STR[$KONF["sprache"]]["idle"]."</b></font>",$buffer); 
    $buffer = str_replace("IDLE", "<font color=green><b>".$STR[$KONF["sprache"]]["idle"]."</b></font>",$buffer); 
    $buffer = str_replace("STOR", "<font color=red><b>".$STR[$KONF["sprache"]]["STOR"]."</b></font>",$buffer); 
    $buffer = str_replace("LIST", "<font color=green><b>".$STR[$KONF["sprache"]]["LIST"]."</b></font>",$buffer); 
    $buffer = str_replace("authenticating", "<font color=brown><b>".$STR[$KONF["sprache"]]["auth"]."</b></font>",$buffer); 
    $buffer = str_replace("no users connected", "<font color=green><b>".$STR[$KONF["sprache"]]["nouser"]."</b></font>",$buffer); 

    debug("Ist in dieser Zeile ein Status (RETR,idle,STOR) oder 'user' enthalten ?"); 
    if (strstr($buffer,$STR[$KONF["sprache"]]["LIST"]) || strstr($buffer,$STR[$KONF["sprache"]]["STOR"]) || strstr($buffer,$STR[$KONF["sprache"]]["DELE"]) || strstr($buffer,$STR[$KONF["sprache"]]["RETR"]) || strstr($buffer,$STR[$KONF["sprache"]]["idle"]) || strstr($buffer,$STR[$KONF["sprache"]]["nouser"]) || strstr($buffer,$STR[$KONF["sprache"]]["auth"])) 
     { 
      debug("Ja. Status: Also fett machen"); 
      $output .= "<b><nobr>".$buffer."</nobr></b>"; 
     } 
    elseif (strstr($buffer,"users")) 
     { 
      debug("Ja. User. Also fett und bunt machen"); 
      $output .= "<nobr><font color=\"#4040ff\"><B>".$buffer."</B></font></nobr>"; 
     } 
    else 
     { 
      debug("Nein. Also grau machen"); 
      $output .= "<nobr><font color=\"#404040\">".$buffer."</font></nobr>"; 
     } 
   }
  $output .= "</FONT>\n"; 
  debug("Datei <b>".$PRG["tempfile"]."</b> schlieen"); 
  fclose ($handle); 
  $output .= "<HR>"; 
  debug("Datei <b>".$PRG["tempfile"]."</b> lschen"); 
  unlink($PRG["tempfile"]); 
} 

debug("Wurde dem Browser eine ProzessID (".$_GET["kill_pid"].") bergeben?"); 
if (isset($_GET["kill_pid"])) 
{ 
  debug("Ja. Also Verschlsselungscode prfen."); 
  debug("Ist ".(md5($_GET["kill_pid"]))." = ". $_GET["cs"] ." ?"); 
  if ((md5($_GET["kill_pid"])) === $_GET["cs"])
  {
    debug("Ja. Fhre Befehl <b>".$PRG["killbefehl"]." ".intval($_GET["kill_pid"])." aus"); 
    if ($KONF["kill"] == 1)
    {
        $command  = shell_exec($PRG["killbefehl"]." ".intval($_GET["kill_pid"])); 
    }
    else
    {
        echo '<font face="Verdana">'.$STR[$KONF["sprache"]]["killdeny"]." ".$_GET["kill_pid"].'<hr>';
    }
    debug("Setze nchstes Refresh der Seite auf 5 Sekunden."); 
    $KONF["refresh"] = 5;
    debug("Setze Nachricht auf der Webseite auf <b>".$STR[$KONF["sprache"]]["killwait"]."</b>"); 
    $msg = "<CENTER><b><FONT face=\"arial\" color=\"#c00000\">".$STR[$KONF["sprache"]]["killwait"]."</FONT></b><BR></CENTER>";
  }
  else
  {
    debug("Setze Nachricht auf der Webseite auf <b>".$STR[$KONF["sprache"]]["killfail"]."</b>"); 
    $msg = "<BR><b><FONT face=\"arial\" color=\"#c00000\">".$STR[$KONF["sprache"]]["killfail"]."</FONT></b><BR>";
  }
}
debug("Rufe Funktion write_body auf");  
write_body();
debug("Fertig");
exit;
#### Funktionen ####

function check_version()
{
    global $KONF, $PRG;
    debug("Funktion check_version");  
    debug("Fhre Befehl <b>".$PRG["verbefehl"]."</b> aus und trenne des Strings nach Leerzeichen");  
    $version = explode(" ", shell_exec($PRG["verbefehl"])); 
    debug("Resultat des Befehls war: ");  
    debug($version);  
    debug("Trenne die Version in Unterversionen");  
    $subversion = explode(".", $version[4]);        
    debug("Ist die Hauptversion 1.2 ?");  
    if (($subversion[0] == 1) && ($subversion[1] == 2)) 
    {
        debug("Ja. Prfen der Unterversion...");  
        switch (intval(substr($subversion[2], 0, 2)))         // Prfen der Subversion der 1.2
        {
            case "5":               // wenn 5 (also 1.2.5)
                $return_val = "1.2.5";      // Setze Variable $return_val auf 1.2.5
                break;              // Weitere Prfung abbrechen
            case "6":               // wenn 6 (also 1.2.6)
                $return_val = "1.2.6";      // Setze Variable $return_val auf 1.2.6
                break;              // Weitere Prfung abbrechen
            case "8":
                $return_val = "1.2.8";      // Setze Variable $return_val auf 1.2.8
                if($KONF["singleline"] === "1") // Wenn Konfig singleline dann... 
                 {
                    $PRG["befehl"] .= $PRG["einezeile"]; // Hnge Option dran...
                 }
                break;              // Weitere Prfung abbrechen
            case "9":
                $return_val = "1.2.9";      // Setze Variable $return_val auf 1.2.9
                if($KONF["singleline"] === "1") // Wenn Konfig singleline dann... 
                 {
                    $PRG["befehl"] .= $PRG["einezeile"]; // Hnge Option dran...
                 }
                break;              // Weitere Prfung abbrechen
            case "10": 
                    $return_val = "1.2.10";      // Setze Variable $return_val auf 1.2.10 
                        if($KONF["singleline"] === "1") // Wenn Konfig singleline dann... 
                         { 
                            $PRG["befehl"] .= $PRG["einezeile"]; // Hnge Option dran... 
                         } 
                        break;            // Weitere Prfung abbrechen
            default:
                // Nicht untersttzte Version
                $return_val = false;
            }
    }
    elseif (($subversion[0] == 1) && ($subversion[1] == 3)) 
    {
        debug("Nein. 1.3 -> Prfen der Unterversion nicht ntig...");  
        $return_val = $version[4];      // Setze Variable $return_val auf $version  
        if($KONF["singleline"] === "1") // Wenn Konfig singleline dann... 
         { 
            $PRG["befehl"] .= $PRG["einezeile"]; // Hnge Option dran... 
         } 
    }
    else
    {
        debug("Nein.");  
        debug($subversion[0].$subversion[1]);
        $return_val = false;
    }

    debug("Ende der Funktion check_version");  
    return $return_val;
}
function write_body()
{
    global $KONF, $STR, $INT, $msg, $output, $do_refresh, $start_stop;
    debug("Funktion write_body");  
    $body  = "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n"; 
    $body .= " <HTML>\n"; 
    $body .= " <HEAD>\n"; 
    $body .= "  <META http-equiv=\"Content-Type\" content=\"text/html; charset=".$STR[$KONF["sprache"]]["charset"]."\">\n"; 
    if ($do_refresh == true ) $body .= "  <META HTTP-EQUIV=Refresh CONTENT=\"".$KONF["refresh"]."; URL=".$_SERVER["PHP_SELF"]."\">\n"; 
    $body .= "  <TITLE>".$STR[$KONF["sprache"]]["title"]."</TITLE>\n"; 
    $body .= " </HEAD>\n"; 
    $body .= "  <BODY onload=\"window.defaultStatus='".$STR[$KONF["sprache"]]["title"]."';\">\n"; 
    $body .= "   <A href=\"".$_SERVER["PHP_SELF"].$start_stop."\"><FONT face=\"".$KONF["font"]."\" size=\"-2\">".$KONF["button"]."</FONT></A>\n"; 
    $body .= "   <BR>\n"; 
    $body .= "   <FONT face=\"".$KONF["font"]."\"><BIG>".$STR[$KONF["sprache"]]["headline"]."</BIG><BR><small><small><font color=\"#c0c0c0\">Proftpd-Version ".$INT["version"]."</font></small></small></FONT>\n"; 
    $body .= "   $msg\n"; 
    $body .= "   <BR>\n"; 
    $body .= "   ".$output."<BR>\n"; 
    $body .= "  </BODY>\n"; 
    $body .= " </HTML>\n"; 
    debug("Gebe Website aus");
    echo $body; 
    debug("Ende der Funktion write_body");  
}

function debug($variable)
{
    global $KONF;
    if (!$KONF["debug"]) return;
    if (is_array($variable) == 1)
    {
        echo "<FONT size=-2 color=gray face=courier>";
        echo "<HR>";
        print_r($variable);
        echo "<HR>";
        echo "</FONT>";
    }
    else
    {
        echo "<FONT size=-2 face=courier>";
        echo "<BR><b>DEBUG: </b>$variable<BR>";
        echo "</FONT>";
    }
}
### ENDE ### 
?>
